/*****************************************************************************\
*
* create.cpp
*
* create - space object creator class
*
* Authors: Petr Bulek (xbulic00 _AT stud.fit.vutbr.cz)
* PCJohn (peciva _AT fit.vutbr.cz)
* Contributors:
*
* ----------------------------------------------------------------------------
*
* THIS SOFTWARE IS NOT COPYRIGHTED
*
* This source code is offered for use in the public domain.
* You may use, modify or distribute it freely.
*
* This source code is distributed in the hope that it will be useful but
* WITHOUT ANY WARRANTY. ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
* DISCLAIMED. This includes but is not limited to warranties of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*
* If you find the source code useful, authors will kindly welcome
* if you give them credit and keep their names with their source code,
* but do not feel to be forced to do so.
*
\*****************************************************************************/


//pocet teles
int solidCount = 10;

//kolize
bool kolize = false;

//soubor do/ze ktereho se bude ukladat/cist
char fileName[50] = "scene.dat";


bool par_in = false;


//#pragma comment(linker, "/entry:\"mainCRTStartup\"")
//#pragma comment(linker, "/subsystem:\"console\"")


#include <Inventor/SbTime.h>
#include "create.h"
#define PI 3.14159265



SbTime last = SbTime::zero();
SbTime actual= SbTime::zero();;
SbTime delay = SbTime::zero();

#include "SoPerfGraph.h"
#include "SoScreenPositioner.h"

static SoPerfGraph *fpsGraph = NULL;
static SoPerfGraph *fpsGraph1 = NULL;
static SoPerfGraph *fpsGraph2 = NULL;
SoSeparator *root;
SoText2 *text4;
vector<SoSeparator *> ps;
SoPointLight *sunLight;
SoEnvironment *envir;

static SbBool culling = FALSE;

SoPerspectiveCamera *cam;
RECT rect;
long oldX, oldY;
int camSpd = 0;
float camX = 0;
float camY = 0;
float camZ = 24000;
float oldCamX, oldCamY, oldCamZ;
SbRotation r;
float priX, priY, priZ = 0;
float x,y,z,a = 0;
SbVec3f *vec = new SbVec3f;
float m_rotX = 0;
float m_rotY = 0;
double cas = 1;

#ifdef _WIN32
		// wokna
HWND window;
#else
	//linux
	QWidget *window;  		
#endif


class PrimitiveCounterSeparator : public SoSeparator {
  typedef SoSeparator inherited;
public:
  int numTriangles;
  static int renderedTriangles;
  static int notCulledTriangles;

  PrimitiveCounterSeparator() : inherited(), numTriangles(-1) {}

  virtual void GLRenderBelowPath(SoGLRenderAction * action) {
    if (numTriangles == -1) {
      SoGetPrimitiveCountAction pc;
      pc.setCanApproximate(FALSE);
	    pc.apply(this);
	    numTriangles = pc.getTriangleCount();

		SoGetBoundingBoxAction bba(action->getViewportRegion());
		bba.apply(this);
    }

    renderedTriangles += numTriangles;
    
    if (!this->cullTest(action->getState()))
      notCulledTriangles += numTriangles;

    inherited::GLRenderBelowPath(action);
  }
  
  virtual void GLRenderInPath(SoGLRenderAction * action) {
    assert(0 && "Not implemented.");
  }

  virtual void GLRenderOffPath(SoGLRenderAction *) {
    assert(0 && "Not implemented.");
  }
};

int PrimitiveCounterSeparator::renderedTriangles = 0;
int PrimitiveCounterSeparator::notCulledTriangles = 0;


void create::randomize(vector<point> &px, int x)
{
	float pom = 0;

	polomer = 1000 - float(x)/2;
	if (polomer < 500) polomer = 500;

	
	if (x != 0) 
	{	
		for (int i = (int)px.size(); (int)i<p.size(); i++)
		{
			r = polomer + rand()%x;
			r = r/1000;
		
			bod.x = p[i].x;
			bod.y = p[i].y;
			bod.z = p[i].z;

			pom = sqrt(bod.x*bod.x + bod.y*bod.y + bod.z*bod.z);		
			pom = radius / pom;		

			bod.x = (bod.x * pom) ;
			bod.y = (bod.y * pom) ;
			bod.z = (bod.z * pom) ;		
		
			bod1.x = bod.x * r;
			bod1.y = bod.y * r;
			bod1.z = bod.z * r;

			bod1.x = bod1.x - bod.x;
			bod1.y = bod1.y - bod.y;
			bod1.z = bod1.z - bod.z;		
			
			bod.x = p[i].x + bod1.x;
			bod.y = p[i].y + bod1.y;
			bod.z = p[i].z + bod1.z;

			px.push_back(bod);		
		};
	}
	else px = p;
};


SoSeparator* create::buildShape()
{
		
		/*for (int i = 0; i<pointer.size(); i++) {
			cout << pointer[i] << endl;
		}*/
		

		/*for (int i = 0; i<p.size(); i++) {
			cout << p[i].x << endl;
			cout << p[i].y << endl;
			cout << p[i].z << endl;
		}*/


        SoSeparator *root = new PrimitiveCounterSeparator;

        int counter = 0;
        //int size = int(pointer_zal.size())/3;
		int size = int(pointer.size())/3;

		SoCoordinate3 *co = new SoCoordinate3;
        SoTriangleStripSet *strip = new SoTriangleStripSet;		

        for (int i = 0; i<size; i++)
        {
			co->point.set1Value(counter+0, p[pointer[counter]].x,
						                   p[pointer[counter]].y,
										   p[pointer[counter]].z);
			co->point.set1Value(counter+1, p[pointer[counter+1]].x,
										   p[pointer[counter+1]].y,
										   p[pointer[counter+1]].z);
			co->point.set1Value(counter+2, p[pointer[counter+2]].x,
										   p[pointer[counter+2]].y,
										   p[pointer[counter+2]].z);
			strip->numVertices.set1Value((float)i, 3);

            counter = counter + 3;
        };

		root->addChild(co);
        root->addChild(strip);
        return root;
};


void create::shift(point p1)
{
	double pom = 0;
	bool is_in_p = false;
	int pozice = 0;


	//zaokrouhleni (kvuli porovnavani ve vektoru)
	p1.x = int(p1.x * 1000);
	p1.x = p1.x/1000;
	p1.y = int(p1.y * 1000);
	p1.y = p1.y/1000;
	p1.z = int(p1.z * 1000);
	p1.z = p1.z/1000;


	pom_bod->setValue((float)p1.x,(float)p1.y,(float)p1.z);

	out = tree->findPoint(*pom_bod);
	if (out > -1) is_in_p = true;



	if (!is_in_p)
	{
		tree->addPoint(*pom_bod);
		p.push_back(p1);
		pointer_zal.push_back((int)(p.size()-1));
	}
	//else pointer_zal.push_back(pozice);
	else pointer_zal.push_back(out);

};

void create::normal(point &bod, int counter1, int counter2)
{
    float len;
    float avgHeight;	
		bod.x = (p[pointer[counter1]].x + p[pointer[counter2]].x)/2;
		bod.y = (p[pointer[counter1]].y + p[pointer[counter2]].y)/2;
		bod.z = (p[pointer[counter1]].z + p[pointer[counter2]].z)/2;
    avgHeight = (sqrt(p[pointer[counter1]].x * p[pointer[counter1]].x +
                      p[pointer[counter1]].y * p[pointer[counter1]].y +
                      p[pointer[counter1]].z * p[pointer[counter1]].z) +
                 sqrt(p[pointer[counter2]].x * p[pointer[counter2]].x +
                      p[pointer[counter2]].y * p[pointer[counter2]].y +
                      p[pointer[counter2]].z * p[pointer[counter2]].z)) / 2;
		len = sqrt((float)(bod.x*bod.x) + (float)(bod.y*bod.y) + (float)(bod.z*bod.z));
		bod.x *= avgHeight/len;
		bod.y *= avgHeight/len;
		bod.z *= avgHeight/len;
};


SoSeparator* create::divide()
{
	SoSeparator *root = new SoSeparator;

	int counter = 0;
	int pomoc0 = 0;
	int pomoc1 = 0;
	int pomoc2 = 0;    
	int size = (int)pointer.size();
	pointer_zal.clear();

	while (counter < size)
	{
		pomoc.clear();

   		normal(bod, counter, counter+1);
    	pomoc.push_back(bod);

    	normal(bod, counter, counter+2);
    	pomoc.push_back(bod);

    	normal(bod, counter+2, counter+1);
    	pomoc.push_back(bod);
		

		pointer_zal.push_back(pointer[counter]);
		shift(pomoc[0]);
		shift(pomoc[1]);

		shift(pomoc[0]);
		pointer_zal.push_back(pointer[counter+1]);
		shift(pomoc[2]);

		shift(pomoc[1]);
		shift(pomoc[2]);
		pointer_zal.push_back(pointer[counter+2]);

		shift(pomoc[1]);
		shift(pomoc[0]);
		shift(pomoc[2]);


		counter = counter + 3;
	};

	pointer.clear();
	pointer = pointer_zal;

	return root;
};


SoNode* create::display()
{
  SoGroup *root;
	//rozptyl =0;
	float delitel = 2;

	if (!lod) {	

		/*SoLOD *lod = new SoLOD;
		lod->center.setValue(0, 0, 0);
		lod->range.set1Value(0,50);
		lod->range.set1Value(1,130);
		lod->range.set1Value(2,280);
		lod->range.set1Value(3,550);
		lod->range.set1Value(4,850);
		lod->range.set1Value(5,945);
		root = lod;*/		

		root = new SoGroup;

		

		//patri k zapisu vektoru
		//if (!f_in) {
			
			initiate();
			randomize(p1,rozptyl);
			rozptyl = (int)(rozptyl/delitel);
			p = p1;		

			p2 = p;
			divide();		
			randomize(p2,rozptyl);			
			rozptyl = (int)(rozptyl/delitel);
			p = p2;				

			p3 = p;
			divide();		
			randomize(p3,rozptyl);
			rozptyl = (int)(rozptyl/delitel);
			p = p3;		
		
			p4 = p;
			divide();		
			randomize(p4,rozptyl);
			rozptyl = (int)(rozptyl/delitel);
			p = p4;				

			p5 = p;
			divide();		
			randomize(p5,rozptyl);
			rozptyl = (int)(rozptyl/delitel);
			p = p5;		
/*			
			p6 = p;
			divide();		
			randomize(p6,rozptyl);
			rozptyl = (int)(rozptyl/delitel);
			p =	p6;		


			p7 = p;
			divide();		
			randomize(p7,rozptyl);
			rozptyl = (int)(rozptyl/delitel);
			p = p7;	*/	
		



		/*zapis a cteni vektoru bodu a ukazatelu na ne
		else {
			cout << "Ze souboru";
			int f_x = 0;
			int f_y = 0;
			int f_nasobitel = 1;
			int f_poz = 0;						
			char s[256];
			int f_i[256];			
			char c;

			fin.open("pointers.dat", fstream::in);
			pointer.clear();
			
			for (int j = 0; j<=in_counter_c; j++) {
				c = ' ';
				while ( c != '*') {
					c = fin.get();
				}
				c = fin.get();
			}

			while (!fin.eof()) {				
				c = fin.get();
				if (c != ' ') {			
					sprintf(s,"%c",c);
					f_i[f_poz] = atoi(s);
					f_poz++;
				}
				else {
					f_poz--;
					for (int i=f_poz; f_poz>=0; f_poz--) {
						f_y = f_i[f_poz] * f_nasobitel;
						f_x = f_x + f_y;
						f_nasobitel = f_nasobitel * 10;
					}
					f_poz = 0;
					f_nasobitel = 1;
					pointer.push_back(f_x);					
					f_x = 0;
				}
			}
			fin.close();


			


			
			point f_bod;
			int f_rot = 0;
			float f_x1 = 0;
			float f_y1 = 0;
			float f_i1[256];
			bool f_minus = false;
			float f_nasobitel1 = 0.001;
			f_poz = 0;

			fin1.open("points.dat", fstream::in);
			p.clear();

			for (int j = 0; j<=in_counter_c; j++) {
				c = ' ';
				while ( c != '*') {
					c = fin1.get();
				}
				c = fin1.get();
			}

			while (!fin1.eof()) {				
				c = fin1.get();
				if (c != ' ') {			
					if (c == '-') {			
						f_minus = true;						
					}
					else {
						if (c == '.') {						
							//nop
						}
						else {
							sprintf(s,"%c",c);
							f_i1[f_poz] = atoi(s);
							f_poz++;
						}
					}
				}
				else {					
					f_poz--;
					for (int i=f_poz; f_poz>=0; f_poz--) {
						f_y1 = f_i1[f_poz] * f_nasobitel1;
						f_x1 = f_x1 + f_y1;
						f_nasobitel1 = f_nasobitel1 * 10;
					}
					if (f_minus) f_x1 = -f_x1;
					f_poz = 0;
					f_nasobitel1 = 0.001;
					f_minus = false;

					if (f_rot == 0) {
						f_bod.x = f_x1;
						f_rot++;
					}
					else {
						if (f_rot == 1) {
							f_bod.y = f_x1;
							f_rot++;
						}
						else {
							if (f_rot == 2) {
								f_bod.z = f_x1;
								p.push_back(f_bod);
								f_rot = 0;
							}
						}
					}
					//cout << f_x1 << endl;
					f_x1 = 0;
				}
			}
			fin1.close();
		}
		
		


		if (f_out) {

			fout.open("pointers.dat", fstream::app|fstream::out);
			char s[256];			
			fout.write("* ",2);
			for (int i = 0; i<pointer.size(); i++) {
				sprintf(s, "%d", pointer[i]);
				fout.write(s,strlen(s));
				fout.write(" ",1);
			}
			fout.close();			
			int f_dig = 0;			
						
			fout1.open("points.dat", fstream::app|fstream::out);
			fout1.write("* ",2);
			int f_pom = 0;
			for (int i = 0; i<p.size(); i++) {
				sprintf(s, "%.3f", p[i].x);
				fout1.write(s,strlen(s));
				fout1.write(" ",1);

				sprintf(s, "%.3f", p[i].y);
				fout1.write(s,strlen(s));
				fout1.write(" ",1);

				sprintf(s, "%.3f", p[i].z);
				fout1.write(s,strlen(s));
				fout1.write(" ",1);				
			}
			fout1.close();
		}
		*/		



		root->addChild(buildShape());
		

		

	}

	else {
		SoLevelOfDetail *level = new SoLevelOfDetail;
		level->screenArea.set1Value(0,15000);
		level->screenArea.set1Value(1,5000);
		level->screenArea.set1Value(2,700);
		level->screenArea.set1Value(3,150);
		level->screenArea.set1Value(4,60);
		level->screenArea.set1Value(5,10);


		/*
		prezentace prepinani
		level->screenArea.set1Value(0,75000);
		level->screenArea.set1Value(1,60000);
		level->screenArea.set1Value(2,45000);
		level->screenArea.set1Value(3,30000);
		level->screenArea.set1Value(4,15000);
		level->screenArea.set1Value(5,10000);
		*/

		root = level;
  

///////////////////////////////JEHHLAN JAKO NEJMENSI DETAIL///////////////////////////////////////////////////////
//	lod->insertChild(createPyramid(),0);
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  

		//SoInfo *nic = new SoInfo;
		//root->insertChild(nic,0);


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////STACI MENIT NA JEDNOM MISTE ///////////////////////////////////////////////////////
////////////////////////////Doporuceni: idealni rozsah promenne rozptyl <je 0 - 1000>/////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

		
		initiate();
		randomize(p1,rozptyl);
		rozptyl = (int)(rozptyl/delitel);
		p = p1;		
		root->insertChild(buildShape(),0);


		p2 = p;
		divide();		
		randomize(p2,rozptyl);			
		rozptyl = (int)(rozptyl/delitel);
		p = p2;		
		root->insertChild(buildShape(),0);

		p3 = p;
		divide();		
		randomize(p3,rozptyl);
		rozptyl = (int)(rozptyl/delitel);
		p = p3;		
		root->insertChild(buildShape(),0);

		
		p4 = p;
		divide();		
		randomize(p4,rozptyl);
		rozptyl = (int)(rozptyl/delitel);
		p = p4;		
		root->insertChild(buildShape(),0);

		p5 = p;
		divide();		
		randomize(p5,rozptyl);
		rozptyl = (int)(rozptyl/delitel);
		p = p5;		
		root->insertChild(buildShape(),0);
/*
		p6 = p;
		divide();		
		randomize(p6,rozptyl);
		rozptyl = (int)(rozptyl/delitel);
		p = p6;		
		root->insertChild(buildShape(),0);
		

		p7 = p;
		divide();		
		randomize(p7,rozptyl);
		rozptyl = (int)(rozptyl/delitel);
		p = p7;		
		root->insertChild(buildShape(),0);
		*/

  }
	return root;
};


void create::initiate()
{
	double posuv_x = 0;
	double posuv_z = 0;
	double posuv_y = 0;

	double rad = radius;
	double x = 0;
	double y = 0;
	double z = 0;

	double pom = 0;
	int pozice = 0;
	int dve = 2;

	posuv_x = rad*sin(45*PI/180);
	posuv_z = posuv_x;
	posuv_y = posuv_x;


	bod.x = x-posuv_x;
	bod.y = y;
	bod.z = z+posuv_z;
	bod.x = bod.x - x;
	bod.y = bod.y - y;
	bod.z = bod.z - z;
	pom = sqrt(bod.x*bod.x + bod.y*bod.y + bod.z*bod.z);
	pom = rad / pom;
	bod.x = (bod.x * pom) + x;
	bod.y = (bod.y * pom) + y;
	bod.z = (bod.z * pom) + z;
	p.push_back(bod);
	pom_bod->setValue((float)bod.x,(float)bod.y,(float)bod.z);
	tree->addPoint(*pom_bod);


	bod.x = x+posuv_x;
	bod.y = y;
	bod.z = z+posuv_z;
	bod.x = bod.x - x;
	bod.y = bod.y - y;
	bod.z = bod.z - z;
	pom = sqrt(bod.x*bod.x + bod.y*bod.y + bod.z*bod.z);
	pom = rad / pom;
	bod.x = (bod.x * pom) + x;
	bod.y = (bod.y * pom) + y;
	bod.z = (bod.z * pom) + z;
	p.push_back(bod);
	pom_bod->setValue((float)bod.x,(float)bod.y,(float)bod.z);
	tree->addPoint(*pom_bod);


	bod.x = x+posuv_x;
	bod.y = y;
	bod.z = z-posuv_z;
	bod.x = bod.x - x;
	bod.y = bod.y - y;
	bod.z = bod.z - z;
	pom = sqrt(bod.x*bod.x + bod.y*bod.y + bod.z*bod.z);
	pom = rad / pom;
	bod.x = (bod.x * pom) + x;
	bod.y = (bod.y * pom) + y;
	bod.z = (bod.z * pom) + z;
	p.push_back(bod);
	pom_bod->setValue((float)bod.x,(float)bod.y,(float)bod.z);
	tree->addPoint(*pom_bod);


	bod.x = x-posuv_x;
	bod.y = y;
	bod.z = z-posuv_z;
	bod.x = bod.x - x;
	bod.y = bod.y - y;
	bod.z = bod.z - z;
	pom = sqrt(bod.x*bod.x + bod.y*bod.y + bod.z*bod.z);
	pom = rad / pom;
	bod.x = (bod.x * pom) + x;
	bod.y = (bod.y * pom) + y;
	bod.z = (bod.z * pom) + z;
	p.push_back(bod);
	pom_bod->setValue((float)bod.x,(float)bod.y,(float)bod.z);
	tree->addPoint(*pom_bod);



	bod.x = x;
	bod.y = y + posuv_y;
	bod.z = z;
	bod.x = bod.x - x;
	bod.y = bod.y - y;
	bod.z = bod.z - z;
	pom = sqrt(bod.x*bod.x + bod.y*bod.y + bod.z*bod.z);
	pom = rad / pom;
	bod.x = (bod.x * pom) + x;
	bod.y = (bod.y * pom) + y;
	bod.z = (bod.z * pom) + z;
	p.push_back(bod);
	pom_bod->setValue((float)bod.x,(float)bod.y,(float)bod.z);
	tree->addPoint(*pom_bod);



	bod.x = x;
	bod.y = y - posuv_y;
	bod.z = z;
	bod.x = bod.x - x;
	bod.y = bod.y - y;
	bod.z = bod.z - z;
	pom = sqrt(bod.x*bod.x + bod.y*bod.y + bod.z*bod.z);
	pom = rad / pom;
	bod.x = (bod.x * pom) + x;
	bod.y = (bod.y * pom) + y;
	bod.z = (bod.z * pom) + z;
	p.push_back(bod);
	pom_bod->setValue((float)bod.x,(float)bod.y,(float)bod.z);
	tree->addPoint(*pom_bod);



	pointer.push_back(0);
	pointer.push_back(1);
	pointer.push_back(4);

	pointer.push_back(1);
	pointer.push_back(2);
	pointer.push_back(4);

	pointer.push_back(2);
	pointer.push_back(3);
	pointer.push_back(4);

	pointer.push_back(3);
	pointer.push_back(0);
	pointer.push_back(4);



	pointer.push_back(0);
	pointer.push_back(5);
	pointer.push_back(1);

	pointer.push_back(1);
	pointer.push_back(5);
	pointer.push_back(2);

	pointer.push_back(2);
	pointer.push_back(5);
	pointer.push_back(3);

	pointer.push_back(3);
	pointer.push_back(5);
	pointer.push_back(0);

	pointer_zal = pointer;
};



SoSeparator* create::createPyramid()
{
	SoSeparator *root = new SoSeparator;

	double posuv_x = 0;
	double posuv_z = 0;
	double posuv_y = 0;

	double pom = 0;	
	int pozice = 0;

	double rad = radius;
	double x = 0;
	double y = 0;
	double z = 0;

	posuv_x = rad*cos(30*PI/180);
	posuv_z = rad*sin(30*PI/180);
	posuv_y = posuv_z*sin(60*PI/180);


	bod.x = x-posuv_x;
	bod.y = y-posuv_y;
	bod.z = z-posuv_z;
	bod.x = bod.x - x;
	bod.y = bod.y - y;
	bod.z = bod.z - z;
	pom = sqrt(bod.x*bod.x + bod.y*bod.y + bod.z*bod.z);
	pom = rad / pom;
	bod.x = (bod.x * pom) + x;
	bod.y = (bod.y * pom) + y;
	bod.z = (bod.z * pom) + z;
	p.push_back(bod);


	bod.x = x+posuv_x;
	bod.y = y-posuv_y;
	bod.z = z-posuv_z;
	bod.x = bod.x - x;
	bod.y = bod.y - y;
	bod.z = bod.z - z;
	pom = sqrt(bod.x*bod.x + bod.y*bod.y + bod.z*bod.z);
	pom = rad / pom;
	bod.x = (bod.x * pom) + x;
	bod.y = (bod.y * pom) + y;
	bod.z = (bod.z * pom) + z;
	p.push_back(bod);

	bod.x = x;
	bod.y = y-posuv_y;
	bod.z = z+2*posuv_z;
	bod.x = bod.x - x;
	bod.y = bod.y - y;
	bod.z = bod.z - z;
	pom = sqrt(bod.x*bod.x + bod.y*bod.y + bod.z*bod.z);	
	pom = rad / pom;
	bod.x = (bod.x * pom) + x;
	bod.y = (bod.y * pom) + y;
	bod.z = (bod.z * pom) + z;
	p.push_back(bod);

	bod.x = x;
	bod.y = y+2*posuv_y;
	bod.z =z;
	bod.x = bod.x - x;
	bod.y = bod.y - y;
	bod.z = bod.z - z;
	pom = sqrt(bod.x*bod.x + bod.y*bod.y + bod.z*bod.z);
	pom = rad / pom;
	bod.x = (bod.x * pom) + x;
	bod.y = (bod.y * pom) + y;
	bod.z = (bod.z * pom) + z;
	p.push_back(bod);


	SoTriangleStripSet *troj;
    SoCoordinate3 *coor;

	coor = new SoCoordinate3;

	coor->point.set1Value(0,(float)p[0].x,(float)p[0].y,(float)p[0].z);
	coor->point.set1Value(1,(float)p[1].x,(float)p[1].y,(float)p[1].z);
	coor->point.set1Value(2,(float)p[2].x,(float)p[2].y,(float)p[2].z);
	coor->point.set1Value(3,(float)p[3].x,(float)p[3].y,(float)p[3].z);
	coor->point.set1Value(4,(float)p[0].x,(float)p[0].y,(float)p[0].z);
	coor->point.set1Value(5,(float)p[1].x,(float)p[1].y,(float)p[1].z);
	
	root->addChild(coor);

	troj = new SoTriangleStripSet;
	troj->numVertices.setValue(6);
	root->addChild(troj);


	p.clear();

	return root;
};



SoSeparator* create::createObject(double rad, int roz)
{
	SoSeparator *root = new SoSeparator;
  if (culling == FALSE)  root->renderCulling = SoSeparator::OFF;

	
	radius = rad;
	rozptyl = roz;
	root->addChild(display());
	return root;
};









//////////////////////  KONSTRUKTORY/DESTRUKTORY  //////////////////////
create::create()
{

	lod = false;

	out = 0;  //pomocna promena pro prohledavani stromu	
	
	pom_bod = new SbVec3f;

	tree = new SbBSPTree;
/*	tree1 = new SbBSPTree;
	tree2 = new SbBSPTree;
	tree3 = new SbBSPTree;
	tree4 = new SbBSPTree;
	tree5 = new SbBSPTree;
	tree6 = new SbBSPTree;*/	
	
};
create::~create() {
};


generating::generating()
{
}

generating::~generating()
{
}



SoSeparator* generating::add_sun(bool l)
{
	SoSeparator *root = new SoSeparator;
	
	SoMaterial *sunMat = new SoMaterial;
  	sunMat->ambientColor.setValue(255,255,0);
  	sunMat->diffuseColor.setValue(255,255,0);
	sunMat->emissiveColor.setValue(255,255,0);
	root->addChild(sunMat);	

	SoTexture2 * t = new SoTexture2;
	t->filename.setValue("tex/sun.jpg");	
	root->addChild(t);

	create c;
	c.lod = l;	
	root->addChild(c.createObject(480,0));	
	SoInfo *info = new SoInfo;
	info->string.setValue("480");
	root->addChild(info);
	return root;
}




SoSeparator* generating::add_rock(int p,int r, bool l, int x, int y, int z)
{
	SoSeparator *root = new SoSeparator;
	
	create c;

	/*SoRotationXYZ *rotY = new SoRotationXYZ;
	rotY->axis = SoRotationXYZ::Y;
	root->addChild(rotY);	
	c.help.x = x;
	c.help.z = z;

	float d = sqrt(c.help.x*c.help.x + c.help.z*c.help.z);

	// Pipojen engine na vstup rotanho node
	SoElapsedTime *counter = new SoElapsedTime;	
	counter->speed.setValue(100/d);
	rotY->angle.connectFrom(&counter->timeOut);
	*/

	int text = 0;
	SoTexture2 * t1 = new SoTexture2;
	text = rand()%11;
	if (text == 0) t1->filename.setValue("tex/earth.jpg");
	if (text == 1) t1->filename.setValue("tex/moon.jpg");
	if (text == 2) t1->filename.setValue("tex/neco.jpg");
	if (text == 3) t1->filename.setValue("tex/mars.jpg");
	if (text == 4) t1->filename.setValue("tex/venus.jpg");
	if (text == 5) t1->filename.setValue("tex/fullmapb.jpg");	
	if (text == 6) t1->filename.setValue("tex/earthmab.jpg");	
	if (text == 7) t1->filename.setValue("tex/jupeqb.jpg");	
	if (text == 8) t1->filename.setValue("tex/marsb.jpg");	
	if (text == 9) t1->filename.setValue("tex/venusmeb.jpg");	
	if (text == 10) t1->filename.setValue("tex/moonb.jpg");		
	root->addChild(t1);

	SoTranslation * tr = new SoTranslation;
	tr->translation.setValue(x,y,z);
	root->addChild(tr);
	
	c.lod = l;	
	root->addChild(c.createObject(p,r));

	SoInfo *info = new SoInfo;
	info->string.setValue(p);		
	root->addChild(info);

	return root;
}


SoSeparator* generating::presentation(bool l, int poc)
{
	SoSeparator *root = new SoSeparator;		
	
	SoTextureCoordinateSphere * sph = new SoTextureCoordinateSphere;
	root->addChild(sph);
	
	root->addChild(add_sun(l));
	
	SoMaterial *mat = new SoMaterial;
	mat->diffuseColor.setValue(1.0f,1.0f,1.0f);
	//mat->ambientColor.setValue(0,0,0);
	//mat->emissiveColor.setValue(0,0,0);
	root->addChild(mat);

		
	int vzdalenost = 1800;
	int pol = 0;
	int bb = 0;

	create c;	
	for (int i = 0; i<(poc/2); i++) {
		cout << poc - 2*i <<endl;
		c.help.x = 500 + rand()%(vzdalenost-510);
		c.help.z = sqrt(vzdalenost*vzdalenost - c.help.x*c.help.x);
		bb = rand()%4;
		if (bb<2) c.help.x = -c.help.x;		
		bb = rand()%4;
		if (bb<2) c.help.z = -c.help.z;

		pol = 5+rand()%85;
		root->addChild(add_rock(pol,100 + rand()%700,l,c.help.x,0,c.help.z));
		pol = 5+rand()%85;
		root->addChild(add_rock(pol,100 + rand()%700,l,-c.help.x,0,-c.help.z));		
		vzdalenost = vzdalenost + 6*pol;
	}	
	return root;
};



SoSeparator* generating::generate(int pocet, int hustota, int polomer, int rozptyl, bool lod)
{
	SoSeparator* root = new SoSeparator();
	SoSeparator* koren = new SoSeparator();

	//create c;
	//c.lod = lod;
	//koren->addChild(c.createObject(polomer,rozptyl));

	SoTranslation *tr_x = new SoTranslation;
	tr_x->translation.setValue((float) hustota,0.0f,0.0f);	
	
	for (int k = 0; k<pocet; k++) {
		int index = rand()%pocet;
		root->addChild(tr_x);
		int text = 0;

	//SoTextureCoordinateSphere * sph = new SoTextureCoordinateSphere;	
	//root->addChild(sph);

	/*SoMaterial *mat = new SoMaterial;
	mat->diffuseColor.setValue(1,0,0);
	root->addChild(mat);*/

/*
	SoTexture2 * t1 = new SoTexture2;
	text = rand()%6;
	if (text == 0) t1->filename.setValue("tex/earth.jpg");
	if (text == 1) t1->filename.setValue("tex/moon.jpg");
	if (text == 2) t1->filename.setValue("tex/neco.jpg");
	if (text == 3) t1->filename.setValue("tex/mars.jpg");
	if (text == 4) t1->filename.setValue("tex/venus.jpg");	
	if (text == 5) t1->filename.setValue("tex/sun.jpg");
	root->addChild(t1);*/


		root->addChild(ps[index]);
	}

	return root;
}





// Time-tick callback
static void timeTickCB(void *data, SoSensor *sensor)
{
	bool move = true;	

	last = actual;
	actual = SbTime::getTimeOfDay(); 

	if (last == SbTime::zero()) delay = SbTime::zero();
	else delay = actual - last;	

	cas = delay.getValue()*90;	

	double help = camSpd * cas;

	priZ = help*cos(a);
	priZ = 4*priZ/5;
	priY = x*help*sin(a);
	priX = y*help*sin(a);

	if (kolize) {
		int polomer = 0;
		SoPath *path;		
		SoInfo *n;
		string sss;
		SbString s;
		SbMatrix matrix;
		SbViewportRegion *region = new SbViewportRegion;
		SoGetMatrixAction *ma = new SoGetMatrixAction(*region);

		for (int i = 0; i<=solidCount; i++) {
			if (i == 0) {
				path = new SoPath;
				path->ref();
				path->setHead(root);
				path->append(7);
				if (par_in) path->append(0);
				path->append(1);
				path->append(3);
				ma->apply(path);				

				n = (SoInfo *) path->getTail();
				path->unref();
				s = n->string.getValue();
				sss = s.getString();

				istringstream myStream(sss);  
				myStream>>polomer;

				//cout << polomer << endl;
				
				
			}
			else {	
				
				path = new SoPath;
				path->ref();
				path->setHead(root);				
				path->append(7);
				if (par_in) path->append(0);
				path->append(2+i);
				path->append(3);				
				ma->apply(path);
				
				n = (SoInfo *) path->getTail();
				path->unref();
				s = n->string.getValue();
				sss = s.getString();

				istringstream myStream(sss);  
				myStream>>polomer;

				//cout << polomer << endl;
				
			}	

			matrix = ma->getMatrix();
			
			SbVec3f *trVec = new SbVec3f;
			SbVec3f *sVec = new SbVec3f;
			SbRotation *rRot = new SbRotation;
			SbRotation *soRot = new SbRotation;

			matrix.getTransform(*trVec, *rRot, *sVec, *soRot);

			float solidX,solidY,solidZ;
			float pomX, pomY, pomZ, dist;
			trVec->getValue(solidX,solidY,solidZ);
			
			pomX = solidX - camX;
			pomY = solidY - camY;
			pomZ = solidZ - camZ;
			
			dist = sqrt(pomX*pomX + pomY*pomY + pomZ*pomZ);
			dist = dist - polomer;	
			
			if ((dist-2) <= 0) move = false;
		}
	}

	if (move) {
		oldCamX = camX;
		oldCamY = camY;
		oldCamZ = camZ;	
		camX = camX - priX;
		camY = camY + priY;
		camZ = camZ - priZ;
	}
	else {	
		camSpd = 0;
		camX = oldCamX;
		camY = oldCamY;
		camZ = oldCamZ;
	}

	cam->position.setValue(camX,camY,camZ);	

	fpsGraph->appendValue(PrimitiveCounterSeparator::renderedTriangles);
	PrimitiveCounterSeparator::renderedTriangles = 0;

	fpsGraph1->appendValue(PrimitiveCounterSeparator::notCulledTriangles);
	PrimitiveCounterSeparator::notCulledTriangles = 0;
	

	fpsGraph2->appendValue(1.f/float(delay.getValue()));

	sensor->schedule();
}; 


void mouseMoveEvent(const SoLocation2Event *event) {

	POINT point;
	GetCursorPos(&point);

	RECT rect;
	GetWindowRect(window, &rect);

	long newX, newY;
	newX = point.x - rect.left;
	newY = point.y - rect.top;
	

	float rot = (float)(newX - oldX) * 0.005f;
	float rotace = (float)(newX - oldX) * 0.005f;
	if(rotace != 0.0) m_rotY += rot;

	if(m_rotY > 2*(float)M_PI) m_rotY -= 2*(float)M_PI;
	if(m_rotY < 0)m_rotY += 2*(float)M_PI;
	
	float newrotX = m_rotX + (float)(newY - oldY) * 0.005f;
	if(fabs(newrotX) < (float)M_PI * 0.35)m_rotX = newrotX;

	SoSFRotation rotateY, rotateX;
    rotateY.setValue(SbVec3f(0, 1, 0), -m_rotY);
    rotateX.setValue(SbVec3f(1, 0, 0), -m_rotX);  
	
	cam->orientation = rotateX.getValue() * rotateY.getValue();	

	//store coordinates for next move
	oldX = rect.left + (rect.right - rect.left)/2;
	oldY = rect.top + (rect.bottom - rect.top)/2;	

	SetCursorPos(oldX, oldY);

	oldX -= rect.left;
	oldY -= rect.top;

	SbRotation r;
	r = cam->orientation.getValue();
	r.getValue(*vec,a);
	vec->getValue(x,y,z);	
	
	/*
	priZ = camSpd*cos(a);
	priZ = 4*priZ/5;
	priY = x*camSpd*sin(a);
	priX = y*camSpd*sin(a);		*/
}




//mouse motion callback
void event_motion(void * userdata, SoEventCallback * node)
{		
	const SoLocation2Event * event = (SoLocation2Event*)node->getEvent();
	mouseMoveEvent(event);
	node->setHandled();
} 



//left mouse click
//right mouse click
void mouseClickEvent(const SoMouseButtonEvent *event)
{
	if(event->getState() == SoButtonEvent::State::DOWN)	{
		if((event->getButton() == SoMouseButtonEvent::BUTTON1)) {
            camSpd = camSpd + 2;			
		}
		if((event->getButton() == SoMouseButtonEvent::BUTTON2)) {
            camSpd = camSpd - 2;			
		}
	}

	SbRotation r;
	r = cam->orientation.getValue();
	r.getValue(*vec,a);
	vec->getValue(x,y,z);	
	
	/*priZ = camSpd*cos(a);
	priZ = 4*priZ/5;
	priY = x*camSpd*sin(a);
	priX = y*camSpd*sin(a);*/


	SbString s;
	s = "Rychlost = ";
	s.addIntString(camSpd/2);
	text4->string.setValue(s);

} 


//mouse click callback
void event_click(void * userdata, SoEventCallback * node)
{	
	const SoMouseButtonEvent * event = (SoMouseButtonEvent*)node->getEvent();
	mouseClickEvent(event);
	node->setHandled();
} 


int main(int argc, char *argv[])
{



	cout << endl;

	//promenne pro vypis
	bool help = false;
	bool par_k = false;
	bool par_l = true;
	bool par_t = false;
	int par_sc = 10;
	int par_hrana = 180;
	int par_pocet = 5;
	bool par_out = false;
	bool in_out_k = false;
	string par_name = "scene.dat";
	int name_size = 9;

	if (argc == 1) {
		cout << "Pouzijte parametr --help nebo -h pro napovedu" << endl;
		cout << "Program bude spusten s implicitnim nastavenim viz napoveda" << endl;
	}

	if (argc > 1) {			
		for (int i=1; i<argc; i++) {
			string parametr = argv[i];
			if (parametr.compare("-h") == 0 || parametr.compare("--help") == 0) {				
				cout << "Napoveda" << endl;
				cout << "--------------------------------------------------------------------------------" << endl;
				cout << "--help      help" << endl;
				cout << "-h          help" << endl;
				cout << "-l          vypnuti zmen detailu (implicitne zapnuta,nereaguje s parametrem in)" << endl;
				cout << "-k          zapnuti kolizi (implicitne vypnuty)" << endl;
				cout << "-sc:count   count = pocet teles generovanych kolem hvezdy (implicitne 10)" << endl;
				cout << "-out        vygenerovana scena bude ulozena do souboru (nelze s parametrem -in)" << endl;
				cout << "-in         scena bude nactena ze souboru (nelze s parametrem -out)" << endl;				
				cout << "-file:name  name = jmeno souboru pro parametry -in a -out (implicitne scene.dat)" << endl;
				cout << "-t          testovaci scena" << endl;
				cout << "-hr:hrana   hrana = vzdalenost teles na hrane testovaci krychle(implicitne 180)" << endl;
				cout << "-sp:pocet   pocet = pocet teles na hrane testovaci krychle (implicitne 5)" << endl;
				cout << "--------------------------------------------------------------------------------" << endl;
				cout << endl;
				help = true;
			}
			if (parametr.compare("-l") == 0) par_l = false;
			if (parametr.compare("-k") == 0) par_k = true;
			if (parametr.compare("-in") == 0) par_in = true;
			if (parametr.compare("-out") == 0) par_out = true;			
			if (parametr.substr(0,4).compare("-sc:") == 0) {
				istringstream myStream(parametr.substr(4, parametr.size()-4));  
				myStream>>par_sc;				
			}
			if (parametr.substr(0,6).compare("-file:") == 0) {
				par_name = parametr.substr(6, parametr.size()-6);				
				for (int k=0; k<par_name.size(); k++) {
					fileName[k] = par_name[k];
				}
				for (int j = par_name.size(); j<name_size; j++) {
					fileName[j] = ' ';
				}
			}
			if (parametr.compare("-t") == 0) par_t = true;
			if (parametr.substr(0,4).compare("-hr:") == 0) {
				istringstream myStream(parametr.substr(4, parametr.size()-4));  
				myStream>>par_hrana;
			}
			if (parametr.substr(0,4).compare("-sp:") == 0) {
				istringstream myStream(parametr.substr(4, parametr.size()-4));  
				myStream>>par_pocet;
			}
			
		}		
	}

	if (!help) {

	cout << endl;
	cout << "KONFIGURACE PROGRAMU:" << endl;
	cout << "---------------------" << endl;

	if ((par_in == true) && (par_out == true)) {
		cout << "Kolize mezi parametry -in a -out, jejich vliv bude potlacen" << endl;
		par_in = false;
		par_out = false;
	}

	if (par_l) cout << "Zmena detailu zapnuta" << endl;
	else cout << "Zmena detailu vypnuta" << endl;

	if (par_k && !par_t ) {
		cout << "Kolize zapnuty" << endl;
		kolize = par_k;
	}
	else cout << "Kolize vypnuty" << endl;

	if (par_in) cout << "Nacteni ze souboru zapnuto" << endl;
	else cout << "Nacteni ze souboru vypnuto" << endl;

	if (par_out) cout << "Zapis do souboru zapnut" << endl;
	else cout << "Zapis do souboru vypnut" << endl;

	if (!par_t) {
		if (!par_in) cout << "Pocet generovanych teles = " << par_sc << endl;		
	}
	else {
		if (!par_in) cout << "Pocet teles na hrane = " << par_pocet << endl;
		if (!par_in) cout << "Vzdalenost teles na hrane = " << par_hrana << endl;
	}

	if (par_in || par_out) cout << "Vystupni/vstupni soubor = " << par_name << endl;


	cout << endl;


	SoDB::init();
	//putenv("COIN_SHOW_FPS_COUNTER=1");
  
	#ifdef _WIN32
		// wokna
		window = SoWin::init(argv[0]);
	#else
		//linux
		window = SoQt::init(argv[0]);  		
	#endif
    if (window == NULL) exit(1);	

		
	// generovani nahodnych cisel
	srand( (unsigned)time( NULL ) );

  	// koren sceny
  	root = new SoSeparator;
  	root->ref();
    if (culling == FALSE)  root->renderCulling = SoSeparator::OFF;


	

	

/**********toto bude zadavano paramery***************************************************/

	
	//polomer generovaneho telesa
	int rad = 50;
	//rozptyl (hrbolatost) generovaneho telesa
	int roz = 800;
	//pouzit / nepouzit lod
	bool l = false;

/*****************************************************************************************/
/*
	SoTranslation *tr_y = new SoTranslation;
	SoTranslation *tr_yb = new SoTranslation;
	SoTranslation *tr_z = new SoTranslation;
	tr_y->translation.setValue(0,hustota,0);
	tr_yb->translation.setValue(0,-hrana*hustota,0);
	tr_z->translation.setValue(0,0,hustota);	


	generating g;

	for (int i = 0; i<hrana; i++) {
		cout << hrana - i - 1 << endl;
		root->addChild(tr_z);
		for (int j = 0; j<hrana; j++) {
			root->addChild(tr_y);
			root->addChild(g.generate(hrana,hustota,rad,roz,l));
		}
		root->addChild(tr_yb);
	}
*/
		
	
	
		if (par_in) {			
			SoInput in;
			cout << "Nacitam ze souboru.." << endl;
				

				bool b = in.openFile(fileName);
				

				if (b) {
					SoSeparator * r = SoDB::readAll(&in);
					root->addChild(r);
			
				
					//pocitani trojuhelniku pri nacitani ze souboru
					SoSearchAction fl;
					fl.setType(SoLevelOfDetail::getClassTypeId());
					fl.setInterest(SoSearchAction::ALL);
					fl.apply(root);

					SoPathList &pl = fl.getPaths();
				

					for (int j=0; j<pl.getLength(); j++) {
						SoPath *path = pl[j];
						SoLevelOfDetail *lod = (SoLevelOfDetail *)path->getTail();
						//assert(lod->isOfType(SoLevelOfDetail::getClassTypeId()) && "Node is not SoLevelOfDetail.");

						for (int i=0; i<lod->getChildren()->getLength(); i++) {
							SoSeparator *origSep = (SoSeparator*)lod->getChild(i);
							SoSeparator *pcs = new PrimitiveCounterSeparator;
							pcs->copyFieldValues(origSep);
							pcs->getChildren()->copy(*origSep->getChildren());  					
							lod->replaceChild(i, pcs);
						}
					}
				}
				else {
					cout << "Soubor se nepodarilo otevrit, pokracuji s implicitnim nastavenim" << endl;
					cout << "Generuji..." << endl;
					generating gen;	
					root->addChild(gen.presentation(par_l,par_sc));
				}
			}
			else {
				if (par_t) {

					SoTextureCoordinateSphere * sph = new SoTextureCoordinateSphere;
					root->addChild(sph);
					SoTexture2 *tex = new SoTexture2;
					tex->filename.setValue("tex/moon.jpg");
					root->addChild(tex);

					sunLight = new SoPointLight;
					sunLight->location.setValue(0.0f, 0.0f, 0.0f);
					sunLight->intensity.setValue(0.0f);	
				
					envir = new SoEnvironment;
					envir->ambientIntensity.setValue(4.5f);				

					SoTranslation *tr_y = new SoTranslation;
					SoTranslation *tr_yb = new SoTranslation;
					SoTranslation *tr_z = new SoTranslation;
					tr_y->translation.setValue(0,par_hrana,0);
					tr_yb->translation.setValue(0,-par_pocet*par_hrana,0);
					tr_z->translation.setValue(0,0,par_hrana);

					generating g;		
				
					cout << "Generuji..." << endl;
					for (int r=0; r<par_pocet; r++) {
						SoSeparator* koren = new SoSeparator();
						create c;
						c.lod = par_l;
						cout << par_pocet - r - 1 << endl;
						koren->addChild(c.createObject(rad,roz));
						ps.push_back(koren);					
					}
		
					for (int i = 0; i<par_pocet; i++) {
						root->addChild(tr_z);
						for (int j = 0; j<par_pocet; j++) {
							root->addChild(tr_y);
							root->addChild(g.generate(par_pocet,par_hrana,rad,roz,par_l));
						}
						root->addChild(tr_yb);
					}
				}
				else {
					cout << "Generuji..." << endl;
					generating gen;	
					root->addChild(gen.presentation(par_l,par_sc));
				}

				if (par_out) {
					cout << "Ukladam...." << endl;
					SoOutput out;
					out.setBinary(true);
					if (out.openFile(fileName)) {
						SoWriteAction wa(&out);
						wa.apply(root);
					}				
				}
			}
	
	

		
	// create FPS performace graph	
	SoPerfGraph::initClass();
	
	fpsGraph = new SoPerfGraph();
	fpsGraph->horScreenOrigin.setValue(SoPerfGraph::RIGHT);
	fpsGraph->horAlignment.setValue(SoPerfGraph::RIGHT);
	fpsGraph->position = SbVec2f(-0.03f, 0.03f);
	fpsGraph->size = SbVec2f(0.23f,0.11f);
	root->insertChild(fpsGraph,0); 

	fpsGraph1 = new SoPerfGraph();
	fpsGraph1->horScreenOrigin.setValue(SoPerfGraph::RIGHT);
	fpsGraph1->horAlignment.setValue(SoPerfGraph::RIGHT);
	fpsGraph1->position = SbVec2f(-0.03f, 0.15f);
	fpsGraph1->size = SbVec2f(0.23f,0.11f);
	root->insertChild(fpsGraph1,0);

	fpsGraph2 = new SoPerfGraph();
	fpsGraph2->horScreenOrigin.setValue(SoPerfGraph::RIGHT);
	fpsGraph2->horAlignment.setValue(SoPerfGraph::RIGHT);
	fpsGraph2->position = SbVec2f(-0.03f, 0.27f);
	fpsGraph2->size = SbVec2f(0.23f,0.11f);
	root->insertChild(fpsGraph2,0);

	if (!par_t) {
		envir = new SoEnvironment;
		envir->ambientIntensity.setValue(0.75f);
	}
	root->insertChild(envir,0);

	if (!par_t) {
		sunLight = new SoPointLight;
		sunLight->location.setValue(0.0f, 0.0f, 0.0f);
		sunLight->intensity.setValue(1.2f);	
	}
	root->insertChild(sunLight,0);


	cam = new SoPerspectiveCamera;	
	cam->position.setValue(camX,camY,camZ);
	cam->orientation.setValue(SbRotation(SbVec3f(0, 0, 1), 0.0f));
	cam->farDistance.setValue(500000);
	root->insertChild(cam,0); 

	//sensor pro pohyb mysi
	SoEventCallback * cb = new SoEventCallback;
	cb->addEventCallback(SoLocation2Event::getClassTypeId(), event_motion); 
	cb->addEventCallback(SoMouseButtonEvent::getClassTypeId(), event_click); 
	root->insertChild(cb, 0);

	// timeTick sensor
	SoOneShotSensor *timeTickSensor = new SoOneShotSensor(timeTickCB, NULL);
	timeTickSensor->schedule();

	

	SoAnnotation *posRoot = new SoAnnotation;
	root->addChild(posRoot);	

	SoScreenPositioner::initClass();

	SoTexture2 *tex1 = new SoTexture2;
	//tex1->filename.setValue("tex/moon.jpg");
	posRoot->addChild(tex1);

	SoScreenPositioner *scrPos1 = new SoScreenPositioner;			
	scrPos1->screenPosition.setValue(332, -80);
	posRoot->addChild(scrPos1);

	SoText2 *text1 = new SoText2;
	text1->string.setValue("- FPS");
	posRoot->addChild(text1);


	SoScreenPositioner *scrPos2 = new SoScreenPositioner;			
	scrPos2->screenPosition.setValue(260, -150);
	posRoot->addChild(scrPos2);

	SoText2 *text2 = new SoText2;
	text2->string.setValue("- viditel. troj.");
	posRoot->addChild(text2);


	SoScreenPositioner *scrPos3 = new SoScreenPositioner;			
	scrPos3->screenPosition.setValue(268, -220);
	posRoot->addChild(scrPos3);

	SoText2 *text3 = new SoText2;
	text3->string.setValue("- vsechny troj.");
	posRoot->addChild(text3);


	SoScreenPositioner *scrPos4 = new SoScreenPositioner;			
	scrPos4->screenPosition.setValue(-380, -280);
	posRoot->addChild(scrPos4);

	text4 = new SoText2;	
	text4->string.setValue("Rychlost = 0");
	posRoot->addChild(text4);


	


#if 0 // demonstrace bugy v SoTextureCoordinateSphere
	SoTextureCoordinateSphere * sph = new SoTextureCoordinateSphere;
	root->addChild(sph);

	SoTexture2 *tex = new SoTexture2;
	tex->filename.setValue("tex/1.jpg");
	root->addChild(tex);

	create c;
	c.lod = true;
	root->addChild(c.createObject(2,2));

	//SoSphere *sp = new SoSphere;
	//root->addChild(sp);
#endif





#if 0 // prezentace prepinani
	SoTextureCoordinateSphere * sph = new SoTextureCoordinateSphere;
	//SoTextureCoordinateDefault * sph = new SoTextureCoordinateDefault;
	//SoTextureCoordinateCube * sph = new SoTextureCoordinateCube;
	root->addChild(sph);

	SoTexture2 * t = new SoTexture2;
	t->filename.setValue("tex/venus.jpg");	
	root->addChild(t);
		
	create c;
	create c1;
	c.lod = true;
	c1.lod = true;
		
	SoTranslation * t2 = new SoTranslation;
	t2->translation.setValue(0,0,-50);
	root->addChild(t2);

	root->addChild(c.createObject(3,2));

	SoTranslation * t1 = new SoTranslation;
	t1->translation.setValue(15,0,0);
	root->addChild(t1);


	root->addChild(c1.createObject(2,2));
#endif
  
	
	

	

	#ifdef _WIN32
		// okno prohlizece
  		//SoWinExaminerViewer *viewer = new SoWinExaminerViewer(window);
  		//SoWinFlyViewer *viewer = new SoWinFlyViewer(window);
		SoWinRenderArea *viewer = new SoWinRenderArea(window); 
	#else
		// okno prohlizece
  		SoQtExaminerViewer *viewer = new SoQtExaminerViewer(window);
  		//SoQtFlyViewer *viewer = new SoQtFlyViewer(window);
	#endif


		
	SetWindowPos(window, HWND_TOPMOST, 20, 20, 800, 600, 0);

	/*#ifdef _DEBUG
		//SetWindowPos(window, HWND_TOPMOST, 640, 0, 400, 300, 0);
		SetWindowPos(window, HWND_TOPMOST, 20, 20, 800, 600, 0);
	#else 
		SetWindowPos(window, HWND_TOPMOST, 200, 200, 800, 600, 0);
	#endif 
	*/

		

		
  	viewer->setSceneGraph(root);
  	viewer->setTitle("Deleni trojuhelniku");  	
  	viewer->show();
		

	


    if (culling == FALSE) {
		SoSeparator *superRoot = (SoSeparator*)SoNode::getByName(SbName("sowin->userscenegraphroot"));
		if (superRoot) superRoot->renderCulling = SoSeparator::OFF;
    }


	//WinAPI code - initialize mouselook  
	GetWindowRect(window, &rect);  
  
	oldX = (rect.right - rect.left)/2;
	oldY = (rect.bottom - rect.top)/2;

	SetCursorPos(rect.left + oldX, rect.top + oldY); 

	ShowCursor(false); 

	// renderovaci smycka
	#ifdef _WIN32		
  		SoWin::show(window);
  		SoWin::mainLoop();
	#else
		// renderovaci smycka
  		SoQt::show(window);
  		SoQt::mainLoop();
	#endif

	



  	// uvolneni pameti
  	delete viewer;
  	root->unref();

	}

  	return 0;

};
