/*****************************************************************************\
*
* create.h
*
* create - space object creator header
*
* Authors: Petr Bulek (xbulic00 _AT stud.fit.vutbr.cz)
* PCJohn (peciva _AT fit.vutbr.cz)
* Contributors:
*
* ----------------------------------------------------------------------------
*
* THIS SOFTWARE IS NOT COPYRIGHTED
*
* This source code is offered for use in the public domain.
* You may use, modify or distribute it freely.
*
* This source code is distributed in the hope that it will be useful but
* WITHOUT ANY WARRANTY. ALL WARRANTIES, EXPRESS OR IMPLIED ARE HEREBY
* DISCLAIMED. This includes but is not limited to warranties of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*
* If you find the source code useful, authors will kindly welcome
* if you give them credit and keep their names with their source code,
* but do not feel to be forced to do so.
*
\*****************************************************************************/

#include <math.h>
#include <cstdlib>
#include <ctime>
#include <iostream>
#include <string>
#include <vector>
#include <cctype>
#include <stdio.h>
#include <Inventor/SbLinear.h>
#include <fstream>
#include <stdlib.h>
#include <string> 
#include <sstream> 


#ifdef _WIN32	
	#include <Inventor/Win/SoWin.h>
	#include <Inventor/Win/viewers/SoWinExaminerViewer.h>
	#include <Inventor/Win/viewers/SoWinFlyViewer.h>
#else
	#include <Inventor/Qt/SoQt.h>
	#include <Inventor/Qt/viewers/SoQtExaminerViewer.h>
	#include <Inventor/Qt/viewers/SoQtFlyViewer.h>
#endif

#include <Inventor/nodes/SoEnvironment.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoComplexity.h>
#include <Inventor/nodes/SoPointLight.h>
#include <Inventor/nodes/SoRotationXYZ.h>
#include <Inventor/nodes/SoSeparator.h>
//#include <Inventor/nodes/SoTransformSeparator.h>
#include <Inventor/nodes/SoTexture2.h>
//#include <Inventor/nodes/SoBumpMap.h>
#include <Inventor/nodes/SoSphere.h>
//#include <Inventor/nodes/SoCone.h>
#include <Inventor/nodes/SoLOD.h>
#include <Inventor/nodes/SoInfo.h>
#include <Inventor/nodes/SoLevelOfDetail.h>
#include <Inventor/nodes/SoTranslation.h>
//#include <Inventor/engines/SoComposeVec3f.h>
#include <Inventor/engines/SoElapsedTime.h>
#include <Inventor/nodes/SoTriangleStripSet.h>
#include <Inventor/nodes/SoCoordinate3.h>
#include <Inventor/nodes/SoIndexedTriangleStripSet.h>
//#include <Inventor/SbLinear.h>
#include <Inventor/SbBSPTree.h>
#include <Inventor/nodes/SoTextureCoordinateSphere.h>
#include <Inventor/nodes/SoTextureCoordinateDefault.h> 
#include <Inventor/nodes/SoTextureCoordinateCube.h> 
#include <Inventor/nodes/SoTextureCoordinate2.h> 
#include <Inventor/actions/SoWriteAction.h>
#include <Inventor/actions/SoGetPrimitiveCountAction.h> 
#include <Inventor/sensors/SoOneShotSensor.h> 

//#include <Inventor/elements/SoGLTextureEnabledElement.h>
//#include <Inventor/actions/SoGLRenderAction.h> 
#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/events/SoLocation2Event.h> 
#include <Inventor/nodes/SoEventCallback.h> 
#include <Inventor/fields/SoSFRotation.h>  
#include <Inventor/events/SoMouseButtonEvent.h>
#include <Inventor/actions/SoGetBoundingBoxAction.h>
#include <Inventor/SoPath.h>
#include <Inventor/actions/SoGetMatrixAction.h>
#include <Inventor/SbViewportRegion.h>
#include <Inventor/SbLinear.h>
#include <Inventor/SbString.h>
#include <Inventor/lists/SoPathList.h>
#include <Inventor/actions/SoSearchAction.h> 
#include <Inventor/misc/SoChildList.h> 

#include <Inventor/nodes/SoText2.h> 
#include <Inventor/nodes/SoAnnotation.h> 







using namespace std;


class generating
{
	public:
		SoSeparator* generate(int pocet, int hustota, int polomer, int rozptyl, bool lod);				
		SoSeparator* presentation(bool l, int poc);		
		SoSeparator* add_rock(int p, int r, bool l, int x, int y, int z);
		SoSeparator* add_sun(bool l);
		
		vector<int> coor_x;
		vector<int> coor_y;	

		generating();
		~generating();
};




class create
{

public:

	typedef struct point
	{
		double x;
		double y;
		double z;
	};	

	point bod, bod1, bod2, bod3, help;

	void GLRender(SoGLRenderAction * action);

    void normal(point &bod, int counter1, int counter2);

	SoSeparator* createPyramid();
	SoSeparator* createObject(double rad, int roz);	
	SoSeparator* triangel(float x1, float y1, float z1, float x2, float y2, float z2, float x3, float y3, float z3);

	SoSeparator* triangel1(int x, int y, int z);	

	SoSeparator* triangel(SbVec3f p1, SbVec3f p2, SbVec3f p3);
	SoSeparator* buildShape();

	SoNode* display();
	SoSeparator* divide();

	void randomize(vector<point> &px, int x);
	void initiate();
	void shift(point p1);

	vector<point> p;
	vector<point> p1;
	vector<point> p2;
	vector<point> p3;
	vector<point> p4;
	vector<point> p5;
	vector<point> p6;
	vector<point> p7;
	vector<point> p8;
	vector<point> pom;

	vector<int> pointer;
	vector<int> pointer_zal;
	vector<point> pomoc;

	fstream fin;
	fstream fin1;
	fstream fout;
	fstream fout1;

	bool lod;

	SbVec3f *pom_bod;

	SbBSPTree *tree;
	SbBSPTree *tree1;
	SbBSPTree *tree2;
	SbBSPTree *tree3;
	SbBSPTree *tree4;
	SbBSPTree *tree5;
	SbBSPTree *tree6;
	SbBSPTree *tree7;

	double x,y,z;

	
	double radius;

	double r;
	int r1;

	int rozptyl;

	float polomer;
	int out;

	create();
	~create();
};
